package com.example.aitest.controller;


import com.alibaba.fastjson.JSONObject;
import com.example.aitest.dto.ApiDto;
import com.example.aitest.service.ApiService;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import javax.annotation.Resource;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Base64;
import java.util.UUID;

@RestController //注解标识这是一个控制器类
@CrossOrigin    //加上CrossOrigin可解决跨域问题
public class ApiController {

    @Resource
    ApiService openAiService;

    @RequestMapping("/apiSend")
    public JSONObject apiSend(@RequestBody ApiDto apiDto) throws IOException {
        // 解码Base64
        byte[] decodedBytes = Base64.getDecoder().decode(apiDto.getImage().split(",")[1]);

        // 设置保存路径
        // 动态生成文件名
        String uniqueFileName = UUID.randomUUID().toString() + ".png";
        Path path = Paths.get("static/images/avatar/" + uniqueFileName);
        Files.createDirectories(path.getParent());
        Files.write(path, decodedBytes);
        // 调用OpenAI API
        return openAiService.processImage(path.toFile());
    }

}
