package com.example.aitest.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.example.aitest.service.ApiService;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.springframework.stereotype.Service;

import java.io.File;
import java.io.IOException;

@Service
public class ApiServiceImpl implements ApiService {
    private static final String API_SECRET_KEY = "sk-zk23dcb27bb18e67d9ea0d749ed62f8088a667936c4c0682";
    private static final String BASE_URL = "https://api.zhizengzeng.com/v1/chat/completions";

    @Override
    public JSONObject processImage(File imageFile) {
        CloseableHttpClient httpClient = HttpClients.createDefault();
        System.out.println("进入processImage");
        // 构建请求体
        JSONObject content = new JSONObject();
        content.put("type", "text");
        content.put("text", "请你对该图片的人物行为进行分析");

        JSONObject imageContent = new JSONObject();
        imageContent.put("type", "image_url");
        JSONObject imageUrl = new JSONObject();
        imageUrl.put("url", "http://124.71.135.249:8081/images/avatar/" + imageFile.getName());
        imageContent.put("image_url", imageUrl);

        JSONObject message = new JSONObject();
        message.put("role", "user");
        message.put("content", new JSONObject[]{content, imageContent});

        JSONObject requestBodyJson = new JSONObject();
        requestBodyJson.put("model", "gpt-4o");
        requestBodyJson.put("messages", new JSONObject[]{message});
        requestBodyJson.put("max_tokens", 300);

        StringEntity requestEntity = new StringEntity(requestBodyJson.toJSONString(), ContentType.APPLICATION_JSON);

        HttpPost httpPost = new HttpPost(BASE_URL);
        httpPost.setHeader("Authorization", "Bearer " + API_SECRET_KEY);
        httpPost.setHeader("Content-Type", "application/json");
        httpPost.setEntity(requestEntity);
        try (CloseableHttpResponse response = httpClient.execute(httpPost)) {
//            if (response.getCode() != 200) {
//                throw new HttpResponseException(response.getCode(), "Unexpected response status");
//            }
            // Parse the JSON response
            String responseBody = new String(response.getEntity().getContent().readAllBytes());
            JSONObject jsonResponse = JSON.parseObject(responseBody);
            System.out.println(jsonResponse.toJSONString());
            return jsonResponse;
        } catch (IOException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
    }
}
